/*
 * decompose/recompose - firmware tools
 *
 * Copyright (C) 2004 Robert Bowler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


extern int reverse_endian;

unsigned long htocl(unsigned long x)
{
  
  if (reverse_endian)
    return ((x << 24) & 0xff000000) |
      ((x << 8) & 0x00ff0000) |
      ((x >> 8) & 0x0000ff00) |
      ((x >> 24) & 0x000000ff);
  
  else
    return x;
  
}

                                                                                                                                   
unsigned short htocs(unsigned short x)
{
  
  if (reverse_endian)
    return ((x << 8) & 0xff00) |
      ((x >> 8) & 0x00ff);
  
  else
    return x;
  
}

unsigned crc32(unsigned char* data,
	       unsigned len)
{
  unsigned ct, crc=0xFFFFFFFF;
  for (ct = 0;ct < len; ct++)
    {
      int j;
      unsigned i=(data[ct]) ^ ((crc) & 0x000000FF);
      for(j = 8; j > 0; j--)
        {
          if(i & 1)
            i = (i >> 1) ^ 0xEDB88320;
          else
            i >>= 1;
        }
      crc = ((crc) >> 8) ^ i;
    }
  return ~crc;
}


